options(stringsAsFactors = F)
library(seqinr)
library(gtools)

args <- commandArgs(TRUE)
NormShiftFile<-args[1]
OutFile<-args[2]
NormShiftTmp<-read.fasta(NormShiftFile)

NormShift<-list()
for (i in 1:length(NormShiftTmp)){
  NormShift[[i]]<-as.character(NormShiftTmp[[i]])
}

al<-do.call(rbind,NormShift)

consensus<-unlist(lapply(1:ncol(al), function(i)
  ifelse(length(unique(al[,i][al[,i]!="-"]))==1,unique(al[,i][al[,i]!="-"]),
         ifelse(length(unique(al[,i][al[,i]!="-"]))==0,"-",
                ifelse((max(table(al[,i][al[,i]!="-"]))>1),
                       names(which(table(al[,i][al[,i]!="-"])==max(table(al[,i][al[,i]!="-"])))),
                       "?")))))

consensus[which(consensus=="?")]<-"N"
if(length(which(consensus=="-"))==0){
  consensus<-consensus
} else {
  consensus<-consensus[-c(which(consensus=="-"))]
}

write.fasta(list(consensus),"Finalseq",OutFile,nbchar=60)


