#!/bin/R

options(stringsAsFactors = F)
library(seqinr)
library(gtools)
args <- commandArgs(TRUE)
InFile<-args[1]
OutFile<-args[2]

sequences<-read.fasta(InFile)
seqs<-list()
for (i in 1:length(sequences)){
  seqs[[i]]<-as.character(sequences[[i]])
}

al<-do.call(rbind.data.frame,seqs)
colnames(al)<-c(1:ncol(al))

consensus<-unlist(lapply(1:ncol(al), function(i) 
  ifelse(length(unique(al[,i][al[,i]!="-"]))==1,unique(al[,i][al[,i]!="-"]),
         ifelse(length(unique(al[,i][al[,i]!="-"]))==0,"-",
                ifelse((max(table(al[,i][al[,i]!="-"]))>1),
                       names(which(table(al[,i][al[,i]!="-"])==max(table(al[,i][al[,i]!="-"])))),
                       "?")))))


write.fasta(list(consensus),"consensus",OutFile,nbchar=60)

